// TEMPLATES
// ---------
#include <iostream>

using namespace std;

template <typename Type = string >
class vetor {
private:
    Type * vet;
    int tam;
public:
    vetor(int tam) : tam( tam ) {
        vet = new Type[tam]; 
    }     
    
    Type& get( int i ) {
        if( i >= 0 && i < tam )
            return vet[i];
    }   
   
    int tamanho() {
        return tam;
    }
};
// Especialização de Templates
template <>
class vetor<int> {
private:
    int * vet;
    int tam;
public:
    vetor(int tam) : tam( tam ) {
        vet = new int[tam]; 
    }     
    
    int& get( int i ) {
        if( i >= 0 && i < tam )
            return vet[i];
    }   
   
    int tamanho() {
        return tam;
    }
    
    void print() {
        for(int i = 0; i < tam; i++ )
            cout << vet[i] << endl;
    }
};
// Herança de Templates
template< typename T = float> 
class Base {
public:
    T a;
};

// Fixando o tipo do template
class Derivada1 : public Base< double > {
public: 
    Derivada1() {
        a = 123.23;
    }
};
// Mantém um template em aberto
template< typename T1, typename T2 = string, typename T3 = int>
class Derivada2 : public Base< T1 > {
public: 
    T1 d;
    Derivada2() {
        T2 x;
        T3 y;
        Base< T1 >::a = d;
    }
};


int main() {
    Derivada2< char  > d2;
}
